<?php
/**
 * Minify Version 1.0
 * 
 * Plugin written by Jayhunter for
 * 
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 **************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 **************************************************
 */
    require_once('plugins/minify/init.inc.php');

    if (!GALLERY_ADMIN_MODE) {
        cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
    }

    global $CONFIG, $lang_common;
    global $minify_conf_array, $documentation_file, $plugin_name;
    $superCage = Inspekt::makeSuperCage();

    pageheader(sprintf($minify_lang['configure_plugin_x'], $minify_lang['display_name']));


    list($timestamp, $form_token) = getFormToken();

    // get sanitized POST parameters
    if ($superCage->post->keyExists('submit')) {

        //Check if the form token is valid
        if(!checkFormToken()){
            cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
        }


        $config_changes_counter = 0;
        foreach ($minify_conf_array as $conf_key => $conf_value) {
            if (isset($CONFIG[$conf_key]) == TRUE) { // only loop if config value is set --- start


                if ($conf_value['type'] == 'bool') { // type is bool --- start
                    if (($superCage->post->getInt($conf_key) == 1 || $superCage->post->getInt($conf_key) == 0) && $superCage->post->getInt($conf_key) != $CONFIG[$conf_key]) {
                        $CONFIG[$conf_key] = $superCage->post->getInt($conf_key)?1:0;
                        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$conf_key]}' WHERE name='$conf_key'");
                        $config_changes_counter++;
                    }
                } // type is bool --- end          



                if ($conf_value['type'] == 'int') { // type is int --- start
                    if (!array_key_exists('max', $conf_value) || (array_key_exists('max', $conf_value) && $superCage->post->getInt($conf_key) <= $conf_value['max']))
                        if (!array_key_exists('min', $conf_value) || (array_key_exists('min', $conf_value) && $superCage->post->getInt($conf_key) >= $conf_value['min']))
                            if ($superCage->post->getInt($conf_key) != $CONFIG[$conf_key]) {
                                $CONFIG[$conf_key] = $superCage->post->getInt($conf_key);
                                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$conf_key]}' WHERE name='$conf_key'");
                                $config_changes_counter++;
                            }
                } // type is int --- end          


                if ($conf_value['type'] == 'csv') { // type is csv --- start
                    $allowed_csv = explode(',',$conf_value['allowed']);
                    $submitted_csv = explode(',',$superCage->post->getRaw($conf_key));
                    foreach ($submitted_csv as $key => $val) {
                        if(!in_array($val, $allowed_csv)) {
                            unset($submitted_csv[$key]);
                        }
                    }
                    $CONFIG[$conf_key] = implode(',', $submitted_csv);
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$conf_key]}' WHERE name='$conf_key'");
                    $config_changes_counter++;
                } // type is csv --- end          


                if ($conf_value['type'] == 'string' || $conf_value['type'] == 'text') { // type is string --- start
                    // TODO: replace getRaw with getAlnum? getRaw removes spaces and , though ....
                    $CONFIG[$conf_key] = $superCage->post->getRaw($conf_key);
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='".addslashes($CONFIG[$conf_key])."' WHERE name='$conf_key'");
                    $config_changes_counter++;
                } // type is string --- end          


            } // only loop if config value is set --- end
        }
        

        // Get and update file config
        $js_files = unserialize(minify_get_config('plugin_minify_js_storage'));
        foreach ($js_files AS $key => $val) {
            $file = "pmjsf_".md5($key);
            $js_files[$key]['enabled'] = $superCage->post->getRaw($file)?1:0;
        }
        minify_write_config('plugin_minify_js_storage', serialize($js_files));




        $css_files = unserialize(minify_get_config('plugin_minify_css_storage'));
        foreach ($css_files AS $key => $val) {
            $file = "pmcssf_".md5($key);
            $css_files[$key]['enabled'] = $superCage->post->getRaw($file)?1:0;
        }
        minify_write_config('plugin_minify_css_storage', serialize($css_files));
        
        
        
        
        // Write min_groupConfig.php
        
        $path = parse_url($CONFIG['ecards_more_pic_target']);
        $path = $path['path'];
        $groupConf_file = "<?php 
        return array(
        'js' => array(";
        foreach ($js_files AS $key => $val) {
            if ($val['enabled']) {
                $groupConf_file .= "'/{$path}{$key}',";
            }
        }
      
        $groupConf_file .= "),'css' => array(";
        foreach ($css_files AS $key => $val) {
            if ($val['enabled']) {
                $groupConf_file .= "'/{$path}{$key}',";
            }
        }
        
        $groupConf_file .= "));";
        
        file_put_contents('plugins/minify/min_groupsConfig.php', $groupConf_file);
        $config_changes_counter++;
        
        
        
        
    }

    // Set the option outputs for the form variables
    foreach ($minify_conf_array as $conf_key => $conf_value) {
        if (isset($CONFIG[$conf_key]) == TRUE) { // only loop if config value is set --- start


            if ($conf_value['type'] == 'bool') {
                if ($CONFIG[$conf_key] == '1') {
                    $option_output[$conf_key] = 'checked="checked"';
                } else { 
                    $option_output[$conf_key] = '';
                }
            } // type is bool --- end          


            if ($conf_value['type'] == 'csv') {
                $option_output[$conf_key] = $CONFIG[$conf_key];
            } // type is csv --- end          



            if ($conf_value['type'] == 'int') {
                $option_output[$conf_key] = $CONFIG[$conf_key];
            } // type is csv --- end          

            if ($conf_value['type'] == 'string' || $conf_value['type'] == 'text') {
                $option_output[$conf_key] = $CONFIG[$conf_key];
            } // type is csv --- end          


        } // only loop if config value is set --- end
    }


    // start form
    echo <<< EOT
    <form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
EOT;

    starttable('100%',  sprintf($minify_lang['configure_plugin_x'], $minify_lang['display_name']), 2, 'cpg_zebra');    

    // reply with success to changes or no changes made
    if ($superCage->post->keyExists('submit')) {
        echo <<< EOT
    <tr>
        <td class="tableh2" colspan="2">
EOT;
        if ($config_changes_counter > 0) {
            msg_box('', $minify_lang['update_success'], '', '', 'success');
        } else {
            msg_box('', $minify_lang['no_changes'], '', '', 'validation');
        }
        echo <<< EOT
        </td>
    </tr>
EOT;
    }

    // complete form 
    echo <<< EOT

EOT;
    foreach ($minify_conf_array as $conf_key => $conf_value) {
        if (isset($CONFIG[$conf_key]) || $conf_value['type'] == 'separator') { // only loop if config value is set --- start


            if ($conf_value['type'] == 'separator') {
                echo <<< EOT
            <tr>
                <td colspan="2"><h2><b>{$minify_lang[$conf_key]}</b></h2></td>
            </tr>
EOT;
            }


            if ($conf_value['type'] == 'bool') {
                echo <<< EOT
      <tr>
                <td class="tableb" width="50%">
            {$minify_lang[$conf_key]} <a href="plugins/{$plugin_name}/docs/{$documentation_file}.htm#{$conf_key}" class="greybox" title="{$minify_lang[$conf_key]}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a><hr />
                </td>
                <td>
            <input type="checkbox" name="{$conf_key}" id="{$conf_key}" class="checkbox" value="1" {$option_output[$conf_key]} />
            <label for="{$conf_key}" class="clickable_option">{$lang_common['yes']}</label>
                </td>
      </tr>
EOT;
            }


            if ($conf_value['type'] == 'csv') {
                echo <<< EOT
      <tr>
                <td class="tableb" width="50%">
            {$minify_lang[$conf_key]} <a href="plugins/{$plugin_name}/docs/{$documentation_file}.htm#{$conf_key}" class="greybox" title="{$minify_lang[$conf_key]}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
                </td>
                <td>
            <input type="text" name="{$conf_key}" id="{$conf_key}" class="text" value="{$option_output[$conf_key]}" />
            <label for="{$conf_key}" class="clickable_option">Allowed: {$conf_value['allowed']}</label><hr />
                </td>
      </tr>
EOT;
            }



            if ($conf_value['type'] == 'string') {
                echo <<< EOT
      <tr>
        <td class="tableb" width="50%">
            {$minify_lang[$conf_key]}
            <a href="plugins/{$plugin_name}/docs/{$documentation_file}.htm#{$conf_key}" class="greybox" title="{$minify_lang[$conf_key]}">
                <img src="images/help.gif" width="13" height="11" border="0" alt="" />
            </a>
            <hr />
        </td>
        <td>
            <input type="text" name="{$conf_key}" id="{$conf_key}" class="text" value="{$option_output[$conf_key]}" size="30" />
            <label for="{$conf_key}" class="clickable_option"></label>
        </td>
      </tr>
EOT;
            }


            if ($conf_value['type'] == 'text') {
                echo <<< EOT
      <tr>
        <td class="tableb" width="50%">
            {$minify_lang[$conf_key]}
            <a href="plugins/{$plugin_name}/docs/{$documentation_file}.htm#{$conf_key}" class="greybox" title="{$minify_lang[$conf_key]}">
                <img src="images/help.gif" width="13" height="11" border="0" alt="" />
            </a>
            <hr />
        </td>
        <td>
            <textarea name="{$conf_key}" id="{$conf_key}" class="text" cols="30" row="7">{$option_output[$conf_key]}</textarea>
            <label for="{$conf_key}" class="clickable_option"></label>
        </td>
      </tr>
EOT;
            }



            if ($conf_value['type'] == 'int') {
                echo <<< EOT
      <tr>
                <td class="tableb" width="50%">
            {$minify_lang[$conf_key]} <a href="plugins/{$plugin_name}/docs/{$documentation_file}.htm#{$conf_key}" class="greybox" title="{$minify_lang[$conf_key]}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a><hr />
                </td>
                <td>
            <input type="text" name="{$conf_key}" id="{$conf_key}" class="text" value="{$option_output[$conf_key]}"/>
            <label for="{$conf_key}" class="clickable_option">min: {$conf_value['min']} max: {$conf_value['max']} default: {$conf_value['default']}</label>
                </td>
      </tr>
EOT;
            }


        }
    }







        echo <<< EOT
    <tr>
        <td colspan="2"><h2><b>{$minify_lang['plugin_minify_js_files']}</b></h2></td>
    </tr>
EOT;

foreach (unserialize(minify_get_config('plugin_minify_js_storage')) AS $key => $val) {
    $enabled = $val['enabled']? 'checked="checked"':'';
    $file = "pmjsf_".md5($key);
    echo <<< EOT
      <tr>
        <td class="tableb" width="50%">{$key}</td>
        <td class="tableb">
            <input type="checkbox" name="{$file}" class="checkbox" value="1" {$enabled} />
            <label for="{$file}" class="clickable_option">{$minify_lang['minify']}</label>
        </td>
      </tr>
EOT;
}




        echo <<< EOT
    <tr>
        <td colspan="2"><h2><b>{$minify_lang['plugin_minify_css_files']}</b></h2></td>
    </tr>
EOT;
        $css_files = unserialize(minify_get_config('plugin_minify_css_storage'));
        
foreach ($css_files AS $key => $val) {
    $enabled = $val['enabled']? 'checked="checked"':'';
    $file = "pmcssf_".md5($key);
    echo <<< EOT
      <tr>
        <td class="tableb" width="50%">{$key}</td>
        <td class="tableb">
            <input type="checkbox" name="{$file}" class="checkbox" value="1" {$enabled} />
            <label for="{$file}" class="clickable_option">{$minify_lang['minify']}</label>
        </td>
      </tr>
EOT;
}


    

    echo <<< EOT
            <tr>
                <td class="tableb" align="center" colspan="2"><br /><br />
                    <span>
                    <input type="hidden" name="form_token" value="{$form_token}" />
                    <input type="hidden" name="timestamp" value="{$timestamp}" />
                    <input type="submit" name="submit" value="{$minify_lang['submit_change']}" /> 
                    </span>
                </td>
            </tr>
        </td>        
EOT;

    endtable();
    echo <<< EOT
    </form>
EOT;

    pagefooter();
    ob_end_flush();

?>