<?php
/**
 * Minify Version 1.1
 * 
 * Plugin written by Jayhunter for
 * 
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 **************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 **************************************************
 */

if (!defined('IN_COPPERMINE')) {
  die();
}

global $CONFIG, $documentation_file, $minify_lang, $minify_conf_array, $plugin_icon_array;
$plugin_name = 'minify';


// Define icons
$plugin_icon_array['ok'] = cpg_fetch_icon('ok', 0);
$plugin_icon_array['announcement'] = cpg_fetch_icon('announcement', 1);
$plugin_icon_array['documentation'] = cpg_fetch_icon('documentation', 1);
$plugin_icon_array['configure'] = cpg_fetch_icon('config', 1);


// Define the default language array (English)
require_once ("./plugins/minify/lang/english.php");
if (file_exists("./plugins/minify/{$CONFIG['lang']}.php")) {
    require_once ("./plugins/minify/lang/{$CONFIG['lang']}.php");
} 


// Determine the help file link
if (file_exists("./plugins/minify/docs/{$CONFIG['lang']}.htm")) {
    $documentation_file = $CONFIG['lang'];
} else {
    $documentation_file = 'english';
}



// Define the configuration keys
$minify_conf_array = array(  

  'plugin_minify_general_options'=> array('type' => 'separator'),
  'plugin_minify_enable_js'        => array('type' => 'bool', 'min' => '0', 'max' => '1', 'default' => '0'),
  'plugin_minify_enable_css'       => array('type' => 'bool', 'min' => '0', 'max' => '1', 'default' => '0'),
  //'plugin_minify_ignore_upload_php'       => array('type' => 'bool', 'min' => '0', 'max' => '1', 'default' => '1'),

);

function minify_get_config ($key){
    global $CONFIG, $minify_config, $minify_config_initiated;
    if (!$minify_config_initiated) {
        $query = "SELECT * FROM {$CONFIG['TABLE_PREFIX']}plugin_minify_config";
        $result = cpg_db_query($query);
        $minify_config = array();
        while ($row = mysql_fetch_assoc($result)) {
            $minify_config[$row['name']] = $row['value'];
        }
        $minify_config_initiated = true;
    }
    if (array_key_exists($key, $minify_config)) {
        return $minify_config[$key];
    } else {
        return false;
    }
    
}

function minify_write_config ($key, $value) {
    global $CONFIG, $minify_config;
    $query = "INSERT INTO {$CONFIG['TABLE_PREFIX']}plugin_minify_config (name, value) VALUES ('{$key}','" . addslashes($value) . "') ON DUPLICATE KEY UPDATE value = '" . addslashes($value) . "'";
    cpg_db_query($query);
    $minify_config[$key] = $value;
}

//$conf_array = array();

